% Raviart-Thomas Gemischte FE fuer die Laplace-Gleichung in 2D        
clc, clear all, close all                               
% Initialisieren:
load dirichlet.dat; 
load elements.dat; 
load coordinates.dat; 
neumann = [];

% Gitter verfeinern
pre_refine = 3;
for j = 1:pre_refine
    marked = 1:size(elements,1);
    [coordinates,elements,dirichlet,neumann] = ...
        refineRGB(coordinates,elements,dirichlet,neumann,marked);
end
nE = size(elements,1);
nC = size(coordinates,1);

% geometrische Datenstrukturen erstellen
[edge2nodes,element2edges,dirichlet2edges] ...
             = provideGeometricData(elements,dirichlet); 
           
%*** Assemblierung:
% Matrix B

%****** TO DO!

% Matrix C

%****** TO DO!


% erstellen Datenstruktur fuer innere Kanten
IntEdges = [];
BdryEdges = sparse(size(coordinates,1),size(coordinates,1));
for j = 1:size(elements,1)
 for k = 1:3
   startEdge = elements(j,k);
   endEdge   = elements(j,rem(k,3)+1);
   if BdryEdges(endEdge,startEdge) == 0
     BdryEdges(startEdge,endEdge) = j;
   else 
     IntEdges = [IntEdges;[...
                 endEdge,startEdge,BdryEdges(endEdge,startEdge),j]];
     BdryEdges(endEdge,startEdge) = 0; 
   end 
 end  
end  
nI = size(IntEdges,1);


% Matrix D
D          = sparse(3*size(elements,1),size(IntEdges,1));
% Schwerpunkt S berechnen
S = reshape(sum(reshape(coordinates(elements',:),3,2*size(elements,1))) ...
                                                        ,size(elements,1),2)/3;
% Kantenvektor e 
e = coordinates(IntEdges(:,2),:)-coordinates(IntEdges(:,1),:);

for k = 1:size(IntEdges,1)
  h = (coordinates(IntEdges(k,[1,1]),:)-S(IntEdges(k,3:4),:))* ...
                                                      [e(k,2);-e(k,1)]; 

  D([3*(IntEdges(k,3)-1)+[1,2,3],3*(IntEdges(k,4)-1)+[1,2,3]],k) = ...
                        [-e(k,2); e(k,1); -h(1); e(k,2); -e(k,1); h(2)];
end

 
% Gesamtsteifigkeitsmatrix A
 A = sparse(4*size(elements,1)+size(IntEdges,1), ...
            4*size(elements,1)+size(IntEdges,1));
 A = [B ,         C,              D           ; 
      C', sparse(size(C,2),size(C,2)+size(D,2));
      D', sparse(size(D,2),size(C,2)+size(D,2)) ];
    
    
% Volumenkraefte:

%***** TO DO!!!
  

% Berechnen der Loesung:
 x = A\b;

% Graphische Darstellung:
 show(elements,coordinates,full(x),S);




